<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'cancelCapturedPayment' => '\\StructType\\CancelCapturedPayment',
            'commonRequest' => '\\StructType\\CommonRequest',
            'queryRequest' => '\\StructType\\QueryRequest',
            'cancelCapturedPaymentResponse' => '\\StructType\\CancelCapturedPaymentResponse',
            'cancelCapturedPaymentResult' => '\\StructType\\CancelCapturedPaymentResult',
            'commonResponse' => '\\StructType\\CommonResponse',
            'wsResponse' => '\\StructType\\WsResponse',
            'capturePayment' => '\\StructType\\CapturePayment',
            'settlementRequest' => '\\StructType\\SettlementRequest',
            'capturePaymentResponse' => '\\StructType\\CapturePaymentResponse',
            'capturePaymentResult' => '\\StructType\\CapturePaymentResult',
            'createTokenByIban' => '\\StructType\\CreateTokenByIban',
            'ibanRequest' => '\\StructType\\IbanRequest',
            'customerRequest' => '\\StructType\\CustomerRequest',
            'billingDetailsRequest' => '\\StructType\\BillingDetailsRequest',
            'shippingDetailsRequest' => '\\StructType\\ShippingDetailsRequest',
            'extraDetailsRequest' => '\\StructType\\ExtraDetailsRequest',
            'createTokenByIbanResponse' => '\\StructType\\CreateTokenByIbanResponse',
            'createTokenByIbanResult' => '\\StructType\\CreateTokenByIbanResult',
            'paymentResponse' => '\\StructType\\PaymentResponse',
            'orderResponse' => '\\StructType\\OrderResponse',
            'extInfo' => '\\StructType\\ExtInfo',
            'cardResponse' => '\\StructType\\CardResponse',
            'authorizationResponse' => '\\StructType\\AuthorizationResponse',
            'captureResponse' => '\\StructType\\CaptureResponse',
            'customerResponse' => '\\StructType\\CustomerResponse',
            'billingDetailsResponse' => '\\StructType\\BillingDetailsResponse',
            'shippingDetailsResponse' => '\\StructType\\ShippingDetailsResponse',
            'extraDetailsResponse' => '\\StructType\\ExtraDetailsResponse',
            'markResponse' => '\\StructType\\MarkResponse',
            'threeDSResponse' => '\\StructType\\ThreeDSResponse',
            'authenticationRequestData' => '\\StructType\\AuthenticationRequestData',
            'authenticationResultData' => '\\StructType\\AuthenticationResultData',
            'extraResponse' => '\\StructType\\ExtraResponse',
            'subscriptionResponse' => '\\StructType\\SubscriptionResponse',
            'fraudManagementResponse' => '\\StructType\\FraudManagementResponse',
            'riskControl' => '\\StructType\\RiskControl',
            'riskAnalysis' => '\\StructType\\RiskAnalysis',
            'riskAssessments' => '\\StructType\\RiskAssessments',
            'shoppingCartResponse' => '\\StructType\\ShoppingCartResponse',
            'cartItemInfo' => '\\StructType\\CartItemInfo',
            'reactivateToken' => '\\StructType\\ReactivateToken',
            'reactivateTokenResponse' => '\\StructType\\ReactivateTokenResponse',
            'reactivateTokenResult' => '\\StructType\\ReactivateTokenResult',
            'duplicatePayment' => '\\StructType\\DuplicatePayment',
            'paymentRequest' => '\\StructType\\PaymentRequest',
            'orderRequest' => '\\StructType\\OrderRequest',
            'duplicatePaymentResponse' => '\\StructType\\DuplicatePaymentResponse',
            'duplicatePaymentResult' => '\\StructType\\DuplicatePaymentResult',
            'cancelPayment' => '\\StructType\\CancelPayment',
            'cancelPaymentResponse' => '\\StructType\\CancelPaymentResponse',
            'cancelPaymentResult' => '\\StructType\\CancelPaymentResult',
            'cancelRefund' => '\\StructType\\CancelRefund',
            'cancelRefundResponse' => '\\StructType\\CancelRefundResponse',
            'cancelRefundResult' => '\\StructType\\CancelRefundResult',
            'checkThreeDSAuthentication' => '\\StructType\\CheckThreeDSAuthentication',
            'threeDSRequest' => '\\StructType\\ThreeDSRequest',
            'mpiExtensionRequest' => '\\StructType\\MpiExtensionRequest',
            'checkThreeDSAuthenticationResponse' => '\\StructType\\CheckThreeDSAuthenticationResponse',
            'checkThreeDSAuthenticationResult' => '\\StructType\\CheckThreeDSAuthenticationResult',
            'updatePayment' => '\\StructType\\UpdatePayment',
            'updatePaymentResponse' => '\\StructType\\UpdatePaymentResponse',
            'updatePaymentResult' => '\\StructType\\UpdatePaymentResult',
            'updatePaymentDetails' => '\\StructType\\UpdatePaymentDetails',
            'shoppingCartRequest' => '\\StructType\\ShoppingCartRequest',
            'updatePaymentDetailsResponse' => '\\StructType\\UpdatePaymentDetailsResponse',
            'updatePaymentDetailsResult' => '\\StructType\\UpdatePaymentDetailsResult',
            'getPaymentDetails' => '\\StructType\\GetPaymentDetails',
            'extendedResponseRequest' => '\\StructType\\ExtendedResponseRequest',
            'getPaymentDetailsResponse' => '\\StructType\\GetPaymentDetailsResponse',
            'getPaymentDetailsResult' => '\\StructType\\GetPaymentDetailsResult',
            'tokenResponse' => '\\StructType\\TokenResponse',
            'updateToken' => '\\StructType\\UpdateToken',
            'cardRequest' => '\\StructType\\CardRequest',
            'tokenRequest' => '\\StructType\\TokenRequest',
            'updateTokenResponse' => '\\StructType\\UpdateTokenResponse',
            'updateTokenResult' => '\\StructType\\UpdateTokenResult',
            'updateRefund' => '\\StructType\\UpdateRefund',
            'updateRefundResponse' => '\\StructType\\UpdateRefundResponse',
            'updateRefundResult' => '\\StructType\\UpdateRefundResult',
            'cancelSubscription' => '\\StructType\\CancelSubscription',
            'cancelSubscriptionResponse' => '\\StructType\\CancelSubscriptionResponse',
            'cancelSubscriptionResult' => '\\StructType\\CancelSubscriptionResult',
            'refundPayment' => '\\StructType\\RefundPayment',
            'refundPaymentResponse' => '\\StructType\\RefundPaymentResponse',
            'refundPaymentResult' => '\\StructType\\RefundPaymentResult',
            'createTokenFromTransaction' => '\\StructType\\CreateTokenFromTransaction',
            'createTokenFromTransactionResponse' => '\\StructType\\CreateTokenFromTransactionResponse',
            'createTokenFromTransactionResult' => '\\StructType\\CreateTokenFromTransactionResult',
            'verifyThreeDSEnrollment' => '\\StructType\\VerifyThreeDSEnrollment',
            'techRequest' => '\\StructType\\TechRequest',
            'verifyThreeDSEnrollmentResponse' => '\\StructType\\VerifyThreeDSEnrollmentResponse',
            'verifyThreeDSEnrollmentResult' => '\\StructType\\VerifyThreeDSEnrollmentResult',
            'validatePayment' => '\\StructType\\ValidatePayment',
            'validatePaymentResponse' => '\\StructType\\ValidatePaymentResponse',
            'validatePaymentResult' => '\\StructType\\ValidatePaymentResult',
            'getPaymentUuid' => '\\StructType\\GetPaymentUuid',
            'legacyTransactionKeyRequest' => '\\StructType\\LegacyTransactionKeyRequest',
            'getPaymentUuidResponse' => '\\StructType\\GetPaymentUuidResponse',
            'legacyTransactionKeyResult' => '\\StructType\\LegacyTransactionKeyResult',
            'createPayment' => '\\StructType\\CreatePayment',
            'createPaymentResponse' => '\\StructType\\CreatePaymentResponse',
            'createPaymentResult' => '\\StructType\\CreatePaymentResult',
            'createSubscription' => '\\StructType\\CreateSubscription',
            'subscriptionRequest' => '\\StructType\\SubscriptionRequest',
            'createSubscriptionResponse' => '\\StructType\\CreateSubscriptionResponse',
            'createSubscriptionResult' => '\\StructType\\CreateSubscriptionResult',
            'getSubscriptionDetails' => '\\StructType\\GetSubscriptionDetails',
            'getSubscriptionDetailsResponse' => '\\StructType\\GetSubscriptionDetailsResponse',
            'getSubscriptionDetailsResult' => '\\StructType\\GetSubscriptionDetailsResult',
            'updateSubscription' => '\\StructType\\UpdateSubscription',
            'updateSubscriptionResponse' => '\\StructType\\UpdateSubscriptionResponse',
            'updateSubscriptionResult' => '\\StructType\\UpdateSubscriptionResult',
            'cancelToken' => '\\StructType\\CancelToken',
            'cancelTokenResponse' => '\\StructType\\CancelTokenResponse',
            'cancelTokenResult' => '\\StructType\\CancelTokenResult',
            'createToken' => '\\StructType\\CreateToken',
            'createTokenResponse' => '\\StructType\\CreateTokenResponse',
            'createTokenResult' => '\\StructType\\CreateTokenResult',
            'findPayments' => '\\StructType\\FindPayments',
            'findPaymentsResponse' => '\\StructType\\FindPaymentsResponse',
            'findPaymentsResult' => '\\StructType\\FindPaymentsResult',
            'transactionItem' => '\\StructType\\TransactionItem',
            'getTokenDetails' => '\\StructType\\GetTokenDetails',
            'getTokenDetailsResponse' => '\\StructType\\GetTokenDetailsResponse',
            'getTokenDetailsResult' => '\\StructType\\GetTokenDetailsResult',
        );
    }
}
