<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for checkThreeDSAuthenticationResult StructType
 * @subpackage Structs
 */
class CheckThreeDSAuthenticationResult extends WsResponse
{
    /**
     * The commonResponse
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CommonResponse
     */
    public $commonResponse;
    /**
     * The threeDSResponse
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ThreeDSResponse
     */
    public $threeDSResponse;
    /**
     * Constructor method for checkThreeDSAuthenticationResult
     * @uses CheckThreeDSAuthenticationResult::setCommonResponse()
     * @uses CheckThreeDSAuthenticationResult::setThreeDSResponse()
     * @param \StructType\CommonResponse $commonResponse
     * @param \StructType\ThreeDSResponse $threeDSResponse
     */
    public function __construct(\StructType\CommonResponse $commonResponse = null, \StructType\ThreeDSResponse $threeDSResponse = null)
    {
        $this
            ->setCommonResponse($commonResponse)
            ->setThreeDSResponse($threeDSResponse);
    }
    /**
     * Get commonResponse value
     * @return \StructType\CommonResponse|null
     */
    public function getCommonResponse()
    {
        return $this->commonResponse;
    }
    /**
     * Set commonResponse value
     * @param \StructType\CommonResponse $commonResponse
     * @return \StructType\CheckThreeDSAuthenticationResult
     */
    public function setCommonResponse(\StructType\CommonResponse $commonResponse = null)
    {
        $this->commonResponse = $commonResponse;
        return $this;
    }
    /**
     * Get threeDSResponse value
     * @return \StructType\ThreeDSResponse|null
     */
    public function getThreeDSResponse()
    {
        return $this->threeDSResponse;
    }
    /**
     * Set threeDSResponse value
     * @param \StructType\ThreeDSResponse $threeDSResponse
     * @return \StructType\CheckThreeDSAuthenticationResult
     */
    public function setThreeDSResponse(\StructType\ThreeDSResponse $threeDSResponse = null)
    {
        $this->threeDSResponse = $threeDSResponse;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CheckThreeDSAuthenticationResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
