<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createPayment StructType
 * Meta informations extracted from the WSDL
 * - type: tns:createPayment
 * @subpackage Structs
 */
class CreatePayment extends AbstractStructBase
{
    /**
     * The commonRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CommonRequest
     */
    public $commonRequest;
    /**
     * The threeDSRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ThreeDSRequest
     */
    public $threeDSRequest;
    /**
     * The paymentRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PaymentRequest
     */
    public $paymentRequest;
    /**
     * The orderRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OrderRequest
     */
    public $orderRequest;
    /**
     * The cardRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CardRequest
     */
    public $cardRequest;
    /**
     * The customerRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerRequest
     */
    public $customerRequest;
    /**
     * The techRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TechRequest
     */
    public $techRequest;
    /**
     * The shoppingCartRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ShoppingCartRequest
     */
    public $shoppingCartRequest;
    /**
     * The extendedResponseRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ExtendedResponseRequest
     */
    public $extendedResponseRequest;
    /**
     * Constructor method for createPayment
     * @uses CreatePayment::setCommonRequest()
     * @uses CreatePayment::setThreeDSRequest()
     * @uses CreatePayment::setPaymentRequest()
     * @uses CreatePayment::setOrderRequest()
     * @uses CreatePayment::setCardRequest()
     * @uses CreatePayment::setCustomerRequest()
     * @uses CreatePayment::setTechRequest()
     * @uses CreatePayment::setShoppingCartRequest()
     * @uses CreatePayment::setExtendedResponseRequest()
     * @param \StructType\CommonRequest $commonRequest
     * @param \StructType\ThreeDSRequest $threeDSRequest
     * @param \StructType\PaymentRequest $paymentRequest
     * @param \StructType\OrderRequest $orderRequest
     * @param \StructType\CardRequest $cardRequest
     * @param \StructType\CustomerRequest $customerRequest
     * @param \StructType\TechRequest $techRequest
     * @param \StructType\ShoppingCartRequest $shoppingCartRequest
     * @param \StructType\ExtendedResponseRequest $extendedResponseRequest
     */
    public function __construct(\StructType\CommonRequest $commonRequest = null, \StructType\ThreeDSRequest $threeDSRequest = null, \StructType\PaymentRequest $paymentRequest = null, \StructType\OrderRequest $orderRequest = null, \StructType\CardRequest $cardRequest = null, \StructType\CustomerRequest $customerRequest = null, \StructType\TechRequest $techRequest = null, \StructType\ShoppingCartRequest $shoppingCartRequest = null, \StructType\ExtendedResponseRequest $extendedResponseRequest = null)
    {
        $this
            ->setCommonRequest($commonRequest)
            ->setThreeDSRequest($threeDSRequest)
            ->setPaymentRequest($paymentRequest)
            ->setOrderRequest($orderRequest)
            ->setCardRequest($cardRequest)
            ->setCustomerRequest($customerRequest)
            ->setTechRequest($techRequest)
            ->setShoppingCartRequest($shoppingCartRequest)
            ->setExtendedResponseRequest($extendedResponseRequest);
    }
    /**
     * Get commonRequest value
     * @return \StructType\CommonRequest|null
     */
    public function getCommonRequest()
    {
        return $this->commonRequest;
    }
    /**
     * Set commonRequest value
     * @param \StructType\CommonRequest $commonRequest
     * @return \StructType\CreatePayment
     */
    public function setCommonRequest(\StructType\CommonRequest $commonRequest = null)
    {
        $this->commonRequest = $commonRequest;
        return $this;
    }
    /**
     * Get threeDSRequest value
     * @return \StructType\ThreeDSRequest|null
     */
    public function getThreeDSRequest()
    {
        return $this->threeDSRequest;
    }
    /**
     * Set threeDSRequest value
     * @param \StructType\ThreeDSRequest $threeDSRequest
     * @return \StructType\CreatePayment
     */
    public function setThreeDSRequest(\StructType\ThreeDSRequest $threeDSRequest = null)
    {
        $this->threeDSRequest = $threeDSRequest;
        return $this;
    }
    /**
     * Get paymentRequest value
     * @return \StructType\PaymentRequest|null
     */
    public function getPaymentRequest()
    {
        return $this->paymentRequest;
    }
    /**
     * Set paymentRequest value
     * @param \StructType\PaymentRequest $paymentRequest
     * @return \StructType\CreatePayment
     */
    public function setPaymentRequest(\StructType\PaymentRequest $paymentRequest = null)
    {
        $this->paymentRequest = $paymentRequest;
        return $this;
    }
    /**
     * Get orderRequest value
     * @return \StructType\OrderRequest|null
     */
    public function getOrderRequest()
    {
        return $this->orderRequest;
    }
    /**
     * Set orderRequest value
     * @param \StructType\OrderRequest $orderRequest
     * @return \StructType\CreatePayment
     */
    public function setOrderRequest(\StructType\OrderRequest $orderRequest = null)
    {
        $this->orderRequest = $orderRequest;
        return $this;
    }
    /**
     * Get cardRequest value
     * @return \StructType\CardRequest|null
     */
    public function getCardRequest()
    {
        return $this->cardRequest;
    }
    /**
     * Set cardRequest value
     * @param \StructType\CardRequest $cardRequest
     * @return \StructType\CreatePayment
     */
    public function setCardRequest(\StructType\CardRequest $cardRequest = null)
    {
        $this->cardRequest = $cardRequest;
        return $this;
    }
    /**
     * Get customerRequest value
     * @return \StructType\CustomerRequest|null
     */
    public function getCustomerRequest()
    {
        return $this->customerRequest;
    }
    /**
     * Set customerRequest value
     * @param \StructType\CustomerRequest $customerRequest
     * @return \StructType\CreatePayment
     */
    public function setCustomerRequest(\StructType\CustomerRequest $customerRequest = null)
    {
        $this->customerRequest = $customerRequest;
        return $this;
    }
    /**
     * Get techRequest value
     * @return \StructType\TechRequest|null
     */
    public function getTechRequest()
    {
        return $this->techRequest;
    }
    /**
     * Set techRequest value
     * @param \StructType\TechRequest $techRequest
     * @return \StructType\CreatePayment
     */
    public function setTechRequest(\StructType\TechRequest $techRequest = null)
    {
        $this->techRequest = $techRequest;
        return $this;
    }
    /**
     * Get shoppingCartRequest value
     * @return \StructType\ShoppingCartRequest|null
     */
    public function getShoppingCartRequest()
    {
        return $this->shoppingCartRequest;
    }
    /**
     * Set shoppingCartRequest value
     * @param \StructType\ShoppingCartRequest $shoppingCartRequest
     * @return \StructType\CreatePayment
     */
    public function setShoppingCartRequest(\StructType\ShoppingCartRequest $shoppingCartRequest = null)
    {
        $this->shoppingCartRequest = $shoppingCartRequest;
        return $this;
    }
    /**
     * Get extendedResponseRequest value
     * @return \StructType\ExtendedResponseRequest|null
     */
    public function getExtendedResponseRequest()
    {
        return $this->extendedResponseRequest;
    }
    /**
     * Set extendedResponseRequest value
     * @param \StructType\ExtendedResponseRequest $extendedResponseRequest
     * @return \StructType\CreatePayment
     */
    public function setExtendedResponseRequest(\StructType\ExtendedResponseRequest $extendedResponseRequest = null)
    {
        $this->extendedResponseRequest = $extendedResponseRequest;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreatePayment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
