<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createTokenFromTransactionResult StructType
 * @subpackage Structs
 */
class CreateTokenFromTransactionResult extends WsResponse
{
    /**
     * The commonResponse
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CommonResponse
     */
    public $commonResponse;
    /**
     * The paymentResponse
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PaymentResponse
     */
    public $paymentResponse;
    /**
     * The orderResponse
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OrderResponse
     */
    public $orderResponse;
    /**
     * The cardResponse
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CardResponse
     */
    public $cardResponse;
    /**
     * The authorizationResponse
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AuthorizationResponse
     */
    public $authorizationResponse;
    /**
     * The captureResponse
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CaptureResponse
     */
    public $captureResponse;
    /**
     * The customerResponse
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerResponse
     */
    public $customerResponse;
    /**
     * The markResponse
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MarkResponse
     */
    public $markResponse;
    /**
     * The threeDSResponse
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ThreeDSResponse
     */
    public $threeDSResponse;
    /**
     * The extraResponse
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ExtraResponse
     */
    public $extraResponse;
    /**
     * The subscriptionResponse
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SubscriptionResponse
     */
    public $subscriptionResponse;
    /**
     * The fraudManagementResponse
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\FraudManagementResponse
     */
    public $fraudManagementResponse;
    /**
     * The shoppingCartResponse
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ShoppingCartResponse
     */
    public $shoppingCartResponse;
    /**
     * Constructor method for createTokenFromTransactionResult
     * @uses CreateTokenFromTransactionResult::setCommonResponse()
     * @uses CreateTokenFromTransactionResult::setPaymentResponse()
     * @uses CreateTokenFromTransactionResult::setOrderResponse()
     * @uses CreateTokenFromTransactionResult::setCardResponse()
     * @uses CreateTokenFromTransactionResult::setAuthorizationResponse()
     * @uses CreateTokenFromTransactionResult::setCaptureResponse()
     * @uses CreateTokenFromTransactionResult::setCustomerResponse()
     * @uses CreateTokenFromTransactionResult::setMarkResponse()
     * @uses CreateTokenFromTransactionResult::setThreeDSResponse()
     * @uses CreateTokenFromTransactionResult::setExtraResponse()
     * @uses CreateTokenFromTransactionResult::setSubscriptionResponse()
     * @uses CreateTokenFromTransactionResult::setFraudManagementResponse()
     * @uses CreateTokenFromTransactionResult::setShoppingCartResponse()
     * @param \StructType\CommonResponse $commonResponse
     * @param \StructType\PaymentResponse $paymentResponse
     * @param \StructType\OrderResponse $orderResponse
     * @param \StructType\CardResponse $cardResponse
     * @param \StructType\AuthorizationResponse $authorizationResponse
     * @param \StructType\CaptureResponse $captureResponse
     * @param \StructType\CustomerResponse $customerResponse
     * @param \StructType\MarkResponse $markResponse
     * @param \StructType\ThreeDSResponse $threeDSResponse
     * @param \StructType\ExtraResponse $extraResponse
     * @param \StructType\SubscriptionResponse $subscriptionResponse
     * @param \StructType\FraudManagementResponse $fraudManagementResponse
     * @param \StructType\ShoppingCartResponse $shoppingCartResponse
     */
    public function __construct(\StructType\CommonResponse $commonResponse = null, \StructType\PaymentResponse $paymentResponse = null, \StructType\OrderResponse $orderResponse = null, \StructType\CardResponse $cardResponse = null, \StructType\AuthorizationResponse $authorizationResponse = null, \StructType\CaptureResponse $captureResponse = null, \StructType\CustomerResponse $customerResponse = null, \StructType\MarkResponse $markResponse = null, \StructType\ThreeDSResponse $threeDSResponse = null, \StructType\ExtraResponse $extraResponse = null, \StructType\SubscriptionResponse $subscriptionResponse = null, \StructType\FraudManagementResponse $fraudManagementResponse = null, \StructType\ShoppingCartResponse $shoppingCartResponse = null)
    {
        $this
            ->setCommonResponse($commonResponse)
            ->setPaymentResponse($paymentResponse)
            ->setOrderResponse($orderResponse)
            ->setCardResponse($cardResponse)
            ->setAuthorizationResponse($authorizationResponse)
            ->setCaptureResponse($captureResponse)
            ->setCustomerResponse($customerResponse)
            ->setMarkResponse($markResponse)
            ->setThreeDSResponse($threeDSResponse)
            ->setExtraResponse($extraResponse)
            ->setSubscriptionResponse($subscriptionResponse)
            ->setFraudManagementResponse($fraudManagementResponse)
            ->setShoppingCartResponse($shoppingCartResponse);
    }
    /**
     * Get commonResponse value
     * @return \StructType\CommonResponse|null
     */
    public function getCommonResponse()
    {
        return $this->commonResponse;
    }
    /**
     * Set commonResponse value
     * @param \StructType\CommonResponse $commonResponse
     * @return \StructType\CreateTokenFromTransactionResult
     */
    public function setCommonResponse(\StructType\CommonResponse $commonResponse = null)
    {
        $this->commonResponse = $commonResponse;
        return $this;
    }
    /**
     * Get paymentResponse value
     * @return \StructType\PaymentResponse|null
     */
    public function getPaymentResponse()
    {
        return $this->paymentResponse;
    }
    /**
     * Set paymentResponse value
     * @param \StructType\PaymentResponse $paymentResponse
     * @return \StructType\CreateTokenFromTransactionResult
     */
    public function setPaymentResponse(\StructType\PaymentResponse $paymentResponse = null)
    {
        $this->paymentResponse = $paymentResponse;
        return $this;
    }
    /**
     * Get orderResponse value
     * @return \StructType\OrderResponse|null
     */
    public function getOrderResponse()
    {
        return $this->orderResponse;
    }
    /**
     * Set orderResponse value
     * @param \StructType\OrderResponse $orderResponse
     * @return \StructType\CreateTokenFromTransactionResult
     */
    public function setOrderResponse(\StructType\OrderResponse $orderResponse = null)
    {
        $this->orderResponse = $orderResponse;
        return $this;
    }
    /**
     * Get cardResponse value
     * @return \StructType\CardResponse|null
     */
    public function getCardResponse()
    {
        return $this->cardResponse;
    }
    /**
     * Set cardResponse value
     * @param \StructType\CardResponse $cardResponse
     * @return \StructType\CreateTokenFromTransactionResult
     */
    public function setCardResponse(\StructType\CardResponse $cardResponse = null)
    {
        $this->cardResponse = $cardResponse;
        return $this;
    }
    /**
     * Get authorizationResponse value
     * @return \StructType\AuthorizationResponse|null
     */
    public function getAuthorizationResponse()
    {
        return $this->authorizationResponse;
    }
    /**
     * Set authorizationResponse value
     * @param \StructType\AuthorizationResponse $authorizationResponse
     * @return \StructType\CreateTokenFromTransactionResult
     */
    public function setAuthorizationResponse(\StructType\AuthorizationResponse $authorizationResponse = null)
    {
        $this->authorizationResponse = $authorizationResponse;
        return $this;
    }
    /**
     * Get captureResponse value
     * @return \StructType\CaptureResponse|null
     */
    public function getCaptureResponse()
    {
        return $this->captureResponse;
    }
    /**
     * Set captureResponse value
     * @param \StructType\CaptureResponse $captureResponse
     * @return \StructType\CreateTokenFromTransactionResult
     */
    public function setCaptureResponse(\StructType\CaptureResponse $captureResponse = null)
    {
        $this->captureResponse = $captureResponse;
        return $this;
    }
    /**
     * Get customerResponse value
     * @return \StructType\CustomerResponse|null
     */
    public function getCustomerResponse()
    {
        return $this->customerResponse;
    }
    /**
     * Set customerResponse value
     * @param \StructType\CustomerResponse $customerResponse
     * @return \StructType\CreateTokenFromTransactionResult
     */
    public function setCustomerResponse(\StructType\CustomerResponse $customerResponse = null)
    {
        $this->customerResponse = $customerResponse;
        return $this;
    }
    /**
     * Get markResponse value
     * @return \StructType\MarkResponse|null
     */
    public function getMarkResponse()
    {
        return $this->markResponse;
    }
    /**
     * Set markResponse value
     * @param \StructType\MarkResponse $markResponse
     * @return \StructType\CreateTokenFromTransactionResult
     */
    public function setMarkResponse(\StructType\MarkResponse $markResponse = null)
    {
        $this->markResponse = $markResponse;
        return $this;
    }
    /**
     * Get threeDSResponse value
     * @return \StructType\ThreeDSResponse|null
     */
    public function getThreeDSResponse()
    {
        return $this->threeDSResponse;
    }
    /**
     * Set threeDSResponse value
     * @param \StructType\ThreeDSResponse $threeDSResponse
     * @return \StructType\CreateTokenFromTransactionResult
     */
    public function setThreeDSResponse(\StructType\ThreeDSResponse $threeDSResponse = null)
    {
        $this->threeDSResponse = $threeDSResponse;
        return $this;
    }
    /**
     * Get extraResponse value
     * @return \StructType\ExtraResponse|null
     */
    public function getExtraResponse()
    {
        return $this->extraResponse;
    }
    /**
     * Set extraResponse value
     * @param \StructType\ExtraResponse $extraResponse
     * @return \StructType\CreateTokenFromTransactionResult
     */
    public function setExtraResponse(\StructType\ExtraResponse $extraResponse = null)
    {
        $this->extraResponse = $extraResponse;
        return $this;
    }
    /**
     * Get subscriptionResponse value
     * @return \StructType\SubscriptionResponse|null
     */
    public function getSubscriptionResponse()
    {
        return $this->subscriptionResponse;
    }
    /**
     * Set subscriptionResponse value
     * @param \StructType\SubscriptionResponse $subscriptionResponse
     * @return \StructType\CreateTokenFromTransactionResult
     */
    public function setSubscriptionResponse(\StructType\SubscriptionResponse $subscriptionResponse = null)
    {
        $this->subscriptionResponse = $subscriptionResponse;
        return $this;
    }
    /**
     * Get fraudManagementResponse value
     * @return \StructType\FraudManagementResponse|null
     */
    public function getFraudManagementResponse()
    {
        return $this->fraudManagementResponse;
    }
    /**
     * Set fraudManagementResponse value
     * @param \StructType\FraudManagementResponse $fraudManagementResponse
     * @return \StructType\CreateTokenFromTransactionResult
     */
    public function setFraudManagementResponse(\StructType\FraudManagementResponse $fraudManagementResponse = null)
    {
        $this->fraudManagementResponse = $fraudManagementResponse;
        return $this;
    }
    /**
     * Get shoppingCartResponse value
     * @return \StructType\ShoppingCartResponse|null
     */
    public function getShoppingCartResponse()
    {
        return $this->shoppingCartResponse;
    }
    /**
     * Set shoppingCartResponse value
     * @param \StructType\ShoppingCartResponse $shoppingCartResponse
     * @return \StructType\CreateTokenFromTransactionResult
     */
    public function setShoppingCartResponse(\StructType\ShoppingCartResponse $shoppingCartResponse = null)
    {
        $this->shoppingCartResponse = $shoppingCartResponse;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateTokenFromTransactionResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
