<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for customerRequest StructType
 * @subpackage Structs
 */
class CustomerRequest extends AbstractStructBase
{
    /**
     * The billingDetails
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BillingDetailsRequest
     */
    public $billingDetails;
    /**
     * The shippingDetails
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ShippingDetailsRequest
     */
    public $shippingDetails;
    /**
     * The extraDetails
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ExtraDetailsRequest
     */
    public $extraDetails;
    /**
     * Constructor method for customerRequest
     * @uses CustomerRequest::setBillingDetails()
     * @uses CustomerRequest::setShippingDetails()
     * @uses CustomerRequest::setExtraDetails()
     * @param \StructType\BillingDetailsRequest $billingDetails
     * @param \StructType\ShippingDetailsRequest $shippingDetails
     * @param \StructType\ExtraDetailsRequest $extraDetails
     */
    public function __construct(\StructType\BillingDetailsRequest $billingDetails = null, \StructType\ShippingDetailsRequest $shippingDetails = null, \StructType\ExtraDetailsRequest $extraDetails = null)
    {
        $this
            ->setBillingDetails($billingDetails)
            ->setShippingDetails($shippingDetails)
            ->setExtraDetails($extraDetails);
    }
    /**
     * Get billingDetails value
     * @return \StructType\BillingDetailsRequest|null
     */
    public function getBillingDetails()
    {
        return $this->billingDetails;
    }
    /**
     * Set billingDetails value
     * @param \StructType\BillingDetailsRequest $billingDetails
     * @return \StructType\CustomerRequest
     */
    public function setBillingDetails(\StructType\BillingDetailsRequest $billingDetails = null)
    {
        $this->billingDetails = $billingDetails;
        return $this;
    }
    /**
     * Get shippingDetails value
     * @return \StructType\ShippingDetailsRequest|null
     */
    public function getShippingDetails()
    {
        return $this->shippingDetails;
    }
    /**
     * Set shippingDetails value
     * @param \StructType\ShippingDetailsRequest $shippingDetails
     * @return \StructType\CustomerRequest
     */
    public function setShippingDetails(\StructType\ShippingDetailsRequest $shippingDetails = null)
    {
        $this->shippingDetails = $shippingDetails;
        return $this;
    }
    /**
     * Get extraDetails value
     * @return \StructType\ExtraDetailsRequest|null
     */
    public function getExtraDetails()
    {
        return $this->extraDetails;
    }
    /**
     * Set extraDetails value
     * @param \StructType\ExtraDetailsRequest $extraDetails
     * @return \StructType\CustomerRequest
     */
    public function setExtraDetails(\StructType\ExtraDetailsRequest $extraDetails = null)
    {
        $this->extraDetails = $extraDetails;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CustomerRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
