<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for extendedResponseRequest StructType
 * @subpackage Structs
 */
class ExtendedResponseRequest extends AbstractStructBase
{
    /**
     * The isNsuRequested
     * @var bool
     */
    public $isNsuRequested;
    /**
     * The isWalletRequested
     * @var bool
     */
    public $isWalletRequested;
    /**
     * The isBankLabelRequested
     * @var bool
     */
    public $isBankLabelRequested;
    /**
     * Constructor method for extendedResponseRequest
     * @uses ExtendedResponseRequest::setIsNsuRequested()
     * @uses ExtendedResponseRequest::setIsWalletRequested()
     * @uses ExtendedResponseRequest::setIsBankLabelRequested()
     * @param bool $isNsuRequested
     * @param bool $isWalletRequested
     * @param bool $isBankLabelRequested
     */
    public function __construct($isNsuRequested = null, $isWalletRequested = null, $isBankLabelRequested = null)
    {
        $this
            ->setIsNsuRequested($isNsuRequested)
            ->setIsWalletRequested($isWalletRequested)
            ->setIsBankLabelRequested($isBankLabelRequested);
    }
    /**
     * Get isNsuRequested value
     * @return bool|null
     */
    public function getIsNsuRequested()
    {
        return $this->isNsuRequested;
    }
    /**
     * Set isNsuRequested value
     * @param bool $isNsuRequested
     * @return \StructType\ExtendedResponseRequest
     */
    public function setIsNsuRequested($isNsuRequested = null)
    {
        // validation for constraint: boolean
        if (!is_null($isNsuRequested) && !is_bool($isNsuRequested)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isNsuRequested, true), gettype($isNsuRequested)), __LINE__);
        }
        $this->isNsuRequested = $isNsuRequested;
        return $this;
    }
    /**
     * Get isWalletRequested value
     * @return bool|null
     */
    public function getIsWalletRequested()
    {
        return $this->isWalletRequested;
    }
    /**
     * Set isWalletRequested value
     * @param bool $isWalletRequested
     * @return \StructType\ExtendedResponseRequest
     */
    public function setIsWalletRequested($isWalletRequested = null)
    {
        // validation for constraint: boolean
        if (!is_null($isWalletRequested) && !is_bool($isWalletRequested)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isWalletRequested, true), gettype($isWalletRequested)), __LINE__);
        }
        $this->isWalletRequested = $isWalletRequested;
        return $this;
    }
    /**
     * Get isBankLabelRequested value
     * @return bool|null
     */
    public function getIsBankLabelRequested()
    {
        return $this->isBankLabelRequested;
    }
    /**
     * Set isBankLabelRequested value
     * @param bool $isBankLabelRequested
     * @return \StructType\ExtendedResponseRequest
     */
    public function setIsBankLabelRequested($isBankLabelRequested = null)
    {
        // validation for constraint: boolean
        if (!is_null($isBankLabelRequested) && !is_bool($isBankLabelRequested)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isBankLabelRequested, true), gettype($isBankLabelRequested)), __LINE__);
        }
        $this->isBankLabelRequested = $isBankLabelRequested;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ExtendedResponseRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
