<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for mpiExtensionRequest StructType
 * @subpackage Structs
 */
class MpiExtensionRequest extends AbstractStructBase
{
    /**
     * The extensionData
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ExtInfo[]
     */
    public $extensionData;
    /**
     * Constructor method for mpiExtensionRequest
     * @uses MpiExtensionRequest::setExtensionData()
     * @param \StructType\ExtInfo[] $extensionData
     */
    public function __construct(array $extensionData = array())
    {
        $this
            ->setExtensionData($extensionData);
    }
    /**
     * Get extensionData value
     * @return \StructType\ExtInfo[]|null
     */
    public function getExtensionData()
    {
        return $this->extensionData;
    }
    /**
     * This method is responsible for validating the values passed to the setExtensionData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExtensionData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExtensionDataForArrayConstraintsFromSetExtensionData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $mpiExtensionRequestExtensionDataItem) {
            // validation for constraint: itemType
            if (!$mpiExtensionRequestExtensionDataItem instanceof \StructType\ExtInfo) {
                $invalidValues[] = is_object($mpiExtensionRequestExtensionDataItem) ? get_class($mpiExtensionRequestExtensionDataItem) : sprintf('%s(%s)', gettype($mpiExtensionRequestExtensionDataItem), var_export($mpiExtensionRequestExtensionDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The extensionData property can only contain items of type \StructType\ExtInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set extensionData value
     * @throws \InvalidArgumentException
     * @param \StructType\ExtInfo[] $extensionData
     * @return \StructType\MpiExtensionRequest
     */
    public function setExtensionData(array $extensionData = array())
    {
        // validation for constraint: array
        if ('' !== ($extensionDataArrayErrorMessage = self::validateExtensionDataForArrayConstraintsFromSetExtensionData($extensionData))) {
            throw new \InvalidArgumentException($extensionDataArrayErrorMessage, __LINE__);
        }
        $this->extensionData = $extensionData;
        return $this;
    }
    /**
     * Add item to extensionData value
     * @throws \InvalidArgumentException
     * @param \StructType\ExtInfo $item
     * @return \StructType\MpiExtensionRequest
     */
    public function addToExtensionData(\StructType\ExtInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ExtInfo) {
            throw new \InvalidArgumentException(sprintf('The extensionData property can only contain items of type \StructType\ExtInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->extensionData[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MpiExtensionRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
