<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for threeDSResponse StructType
 * @subpackage Structs
 */
class ThreeDSResponse extends AbstractStructBase
{
    /**
     * The authenticationRequestData
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AuthenticationRequestData
     */
    public $authenticationRequestData;
    /**
     * The authenticationResultData
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AuthenticationResultData
     */
    public $authenticationResultData;
    /**
     * Constructor method for threeDSResponse
     * @uses ThreeDSResponse::setAuthenticationRequestData()
     * @uses ThreeDSResponse::setAuthenticationResultData()
     * @param \StructType\AuthenticationRequestData $authenticationRequestData
     * @param \StructType\AuthenticationResultData $authenticationResultData
     */
    public function __construct(\StructType\AuthenticationRequestData $authenticationRequestData = null, \StructType\AuthenticationResultData $authenticationResultData = null)
    {
        $this
            ->setAuthenticationRequestData($authenticationRequestData)
            ->setAuthenticationResultData($authenticationResultData);
    }
    /**
     * Get authenticationRequestData value
     * @return \StructType\AuthenticationRequestData|null
     */
    public function getAuthenticationRequestData()
    {
        return $this->authenticationRequestData;
    }
    /**
     * Set authenticationRequestData value
     * @param \StructType\AuthenticationRequestData $authenticationRequestData
     * @return \StructType\ThreeDSResponse
     */
    public function setAuthenticationRequestData(\StructType\AuthenticationRequestData $authenticationRequestData = null)
    {
        $this->authenticationRequestData = $authenticationRequestData;
        return $this;
    }
    /**
     * Get authenticationResultData value
     * @return \StructType\AuthenticationResultData|null
     */
    public function getAuthenticationResultData()
    {
        return $this->authenticationResultData;
    }
    /**
     * Set authenticationResultData value
     * @param \StructType\AuthenticationResultData $authenticationResultData
     * @return \StructType\ThreeDSResponse
     */
    public function setAuthenticationResultData(\StructType\AuthenticationResultData $authenticationResultData = null)
    {
        $this->authenticationResultData = $authenticationResultData;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ThreeDSResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
